//*----------------------------------------------------------------------------
//*      ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : ext_irq.c
//* Object              : External interrupt handler for irq
//*                     : Use LED5 & LED6 for status interrupt
//* 1.0 24/Jun/04 JPP   : Creation
//* 1.2 29/Aug/05 JPP   : Update AIC definion
//*----------------------------------------------------------------------------

// Include Standard LIB  files
#include "Board.h"

int valeur_registre;//,valeur_registre_RHR;
unsigned int valeur_registre_RHR;
char Message[]=
{"message"};

static const char atmel_header_bis[]=
{
"\n\r  *** ext_irq ATMEL Usart IRQ ***\n\r"
"Copyright (C) 2002 ATMEL Corporations Version: 1.0 (WinARM port)\n\r"
};
//Modification Tibo  ajout constantes suivantes
static const char Message_int_A[]=
{
"\n\r  *** Interruption pio_c_irq_handler Int_A sur PA15 ***\n\r"
};
static const char Message_int_B[]=
{
"\n\r  *** Interruption pio_c_irq_handler Int_B sur PA16 ***\n\r"
};
static const char Message_int_C[]=
{
"\n\r  *** Interruption pio_c_irq_handler Int_C sur PA18 ***\n\r"
};
static const char Message_int_D[]=
{
"\n\r  *** Interruption pio_c_irq_handler Int_D sur PA19 ***\n\r"
};
static const char Message_int_PIOA[]=
{
"\n\r  *** Interruption PIOA ***\n\r"
};
static const char Message_int_others[]=
{
"\n\r  *** Une interruption autre que celles prvues s'est dclenche ***\n\r"
};

//char table[5]={2,4,8,7,10};
//int i=0;
//int status_irq = 0 ;


// --------------------------------------------------------------------- //
//          fonction qui envoie une donne de 8 bits  l'UART			 //
// --------------------------------------------------------------------- //

void envoie_UART(char data,int chipsel)
	{
	volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;					// pointer to PIO data structure
	pPIO->PIO_ODSR = (0x000000FF & data);	// met la donne en sortie et l'adresse du registre THR ('000')
	pPIO->PIO_CODR = chipsel;									// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask;									// Dsactive les UART
	pPIO->PIO_SODR = write;										// dsactivation de l'criture 
	}
// --------------------------------------------------------------------- //

//*----------------------------------------------------------------------------
//* Function Name       : pio_c_irq_handler
//* Object              : Irq Handler called by the irq_pio.s
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : at91_pio_read, at91_pio_write
//*----------------------------------------------------------------------------
__ramfunc void pio_c_irq_handler(void)
{
	//Modification Tibo 3 desactive 2 declarations suivantes pour supprimmer WARNING
	//int dummy=0;
	//int i=0;
	unsigned int interrupt_id;
	AT91PS_PIO pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure
	AT91PS_USART pUS1 = AT91C_BASE_US1;
	//volatile AT91PS_AIC pAIC = AT91C_BASE_AIC;	//pointer to AIC Base Address
    //* Read the output state
	
	//Modification Tibo ajout des if suivant test sur "Quelle interruption???"
	//unsigned int interrupt_id; Dcal au dessus (avec dclarations)
	//interrupt_id=AT91C_BASE_AIC->AIC_IPR;
	
	interrupt_id = AT91F_PIO_GetInterruptStatus(pPIO);

	//pPIO->PIO_ISR;
	//Registre AIC_ISR code sur 5 bit le numero de l'INT donc voir avec ca si AIC est en raport avec les IT de PIO
	if(interrupt_id & 0x8000)
	{
		//Modification Tibo 2 ajout SendFrame()
		AT91F_US_SendFrame(pUS1,(char *)Message,sizeof(Message)-1,0,0);
		AT91F_US_SendFrame(pUS1,(char *)Message_int_A,sizeof(Message_int_A)-1,0,0);
	}
	else if(interrupt_id & 0x10000)
	{
		AT91F_US_SendFrame(pUS1,(char *)Message_int_B,sizeof(Message_int_B)-1,0,0);
	}
	else if(interrupt_id & 0x40000)
	{
		AT91F_US_SendFrame(pUS1,(char *)Message_int_C,sizeof(Message_int_C)-1,0,0);
	}
	else if(interrupt_id & 0x80000)
	{
		AT91F_US_SendFrame(pUS1,(char *)Message_int_D,sizeof(Message_int_D)-1,0,0);
	}
	else if(interrupt_id & 0x4)
	{
		AT91F_US_SendFrame(pUS1,(char *)Message_int_PIOA,sizeof(Message_int_PIOA)-1,0,0);
	}
	else
	{
		AT91F_US_SendFrame(pUS1,(char *)Message_int_others,sizeof(Message_int_others)-1,0,0);
	}
	//Modification Tibo 3 desactive tout jusqu'a fin de cette fonction (*/) except dummy pour enable next interrupt
	AT91F_PIO_CfgInput(pPIO, BUS_DONNEE);	//configure le bus de done en entre
	AT91F_PIO_ClearOutput(pPIO, CS_mask|BUS_ADDRESS);	//adresse du registre RHR & selectionne l'UART A
	AT91F_PIO_ClearOutput(pPIO, read);//pPIO->PIO_CODR = read;
	//for(i=0;i<100;i++){}
	valeur_registre_RHR = (AT91F_PIO_GetInput(pPIO) & 0xFF);//valeur_registre_RHR = (pPIO->PIO_PDSR & 0xFF);
	//AT91F_US_PutChar(pUS1, valeur_registre_RHR);
	//while(1);
	AT91F_PIO_SetOutput(pPIO, read);//pPIO->PIO_SODR = read;
	//valeur_registre_RHR = (pPIO->PIO_PDSR & 0xFF);
	AT91F_US_SendFrame(pUS1,(char *)Message,sizeof(Message)-1,0,0);

    
	AT91F_PIO_CfgOutput(pPIO, BUS_DONNEE);	//Configure le bus de donne en sortie
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|CS_mask|BUS_DONNEE);
	AT91F_PIO_ForceOutput(pPIO, valeur_registre_RHR);	//Writ PIO_ODSR(enabled by writting PIO_OWER during initialisation)
	//pPIO->PIO_ODSR = valeur_registre_RHR ;				//envoie le caractre reu
    //pPIO->PIO_CODR = (A0|A1|A2) ;
	AT91F_PIO_ClearOutput(pPIO, write);
	//for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);
    /*pPIO->PIO_CODR = CS_mask;										// active le l'UART selectionn
    pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    pPIO->PIO_SODR = write;									// Dsactive l'criture*/


	//AT91F_US_PutChar(pUS1, valeur_registre_RHR);
	//pUS1->US_THR = valeur_registre_RHR;//*/
    
    //* enable the next PIO IRQ
	//interrupt_id = AT91F_PIO_GetInterruptStatus(pPIO);
    //dummy =AT91C_BASE_PIOA->PIO_ISR;
    //* suppress the compilation warning
    //dummy =dummy;
    //return;
//    //* while SW3 is push wait
//    while ( (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & SW3_MASK ) != SW3_MASK );
}


//*----------------------------------------------------------------------------
//* Function Name       : at91_IRQ0_handler
//* Object              : Irq Handler called by the IRQ0 interrupt with AT91
//*                       compatibility
//*----------------------------------------------------------------------------
__ramfunc void at91_IRQ0_handler(void)
{
 //   if (status_irq == 0) status_irq = 1;
//    else status_irq = 0 ;
    //* Read the output state
	
//	  AT91PS_USART USART_pt = AT91C_BASE_US1;
//	  AT91PS_USART COM1 = AT91C_BASE_US1;
//	  AT91F_US_PutChar(USART_pt,table[i]);
//        
//	  i++;
//	  if (i>=4)
//	  	{i=0;}
//	  else { }
	  
//	  AT91F_US_PutChar (USART_pt, 'C');
//	  AT91F_US_PutChar (USART_pt, 'h');
//	  AT91F_US_PutChar (USART_pt, 'a');
//	  AT91F_US_PutChar (USART_pt, 'r');
//	  AT91F_US_PutChar (USART_pt, 'l');
//	  AT91F_US_PutChar (USART_pt, 'y');
//	  AT91F_US_PutChar (USART_pt, '1');
//	  AT91F_US_PutChar (USART_pt, "C");
//	  AT91F_US_PutChar (USART_pt, "h");
//	  AT91F_US_PutChar (USART_pt, "a");
//	  AT91F_US_PutChar (USART_pt, "r");
//	  AT91F_US_PutChar (USART_pt, "l");
//	  AT91F_US_PutChar (USART_pt, "y");
//	  AT91F_US_PutChar (USART_pt, "2");
//	  AT91F_US_SendFrame(COM1,"\n Antony",sizeof "\n Antony",0,0);
//	  AT91F_US_PutChar (COM1, 'S');
//	  AT91F_US_PutChar (COM1, 'o');
//	  AT91F_US_PutChar (COM1, 's');
//	  AT91F_US_PutChar (COM1, 's');
//	  AT91F_US_PutChar (COM1, 'o');
//	  AT91F_US_PutChar (COM1, '1');
//	  AT91F_US_PutChar (COM1, "S");
//	  AT91F_US_PutChar (COM1, "o");
//	  AT91F_US_PutChar (COM1, "s");
//	  AT91F_US_PutChar (COM1, "s");
//	  AT91F_US_PutChar (COM1, "o");
//	  AT91F_US_PutChar (COM1, "2");

//	AT91F_PIO_CfgOutput( AT91C_BASE_PIOA, BUS_DONNEE ) ;	  
//  	  if ( (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & LED2 ) == LED2 )
//  	    {
//  		  volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure		  
//  	        AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED2 );
//  	        pPIO->PIO_ODSR = 'S' ;				//envoie du caratre ASCII  'S'
//  	        pPIO->PIO_CODR =(A0|A1|A2) ;
//  	       	pPIO->PIO_CODR = CS_mask;										// active le l'UART selectionn
//  	       	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	        pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//  	        pPIO->PIO_ODSR = 'a'  ;				//envoie du caratre ASCII  'a'
//   	        pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//   	        pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//   	        pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//   	    	pPIO->PIO_ODSR = 'l' ;				//envoie du caratre ASCII  'l'
//   	        pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//   	        pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//   	        pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//   	        pPIO->PIO_ODSR = 'u' ;				//envoie du caratre ASCII  'u'
//  	        pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  	        pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	        pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
// 
//  	        pPIO->PIO_ODSR = 't' ;				//envoie du caratre ASCII  't'
//  	        pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  	        pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	        pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//   	    
//  	        pPIO->PIO_ODSR = ',' ;				//envoie du caratre ASCII  ','
//   	       	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//   	       	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//   	       	pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//  	          	        	        	       	     	        	        	       	
//  	    }
//  	  else
//  	    {
//  		volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure		  
//  	        AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED2 );
//  	        pPIO->PIO_SODR =(D0|D1|D6) ;				//envoie du caratre ASCII (0x43)= 'C'
//  	      	pPIO->PIO_CODR =(D2|D3|D4|D5|D7|A0|A1|A2) ;
//  	       	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  	       	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	       	pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//   	        pPIO->PIO_SODR =(D0|D5|D6) ;				//envoie du caratre ASCII (0x61)= 'a'
//   	      	pPIO->PIO_CODR =(D1|D2|D3|D4|D7) ;
//   	       	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//   	       	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//   	       	pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//   	        pPIO->PIO_SODR =(D2|D3|D5) ;				//envoie du caratre ASCII (0x2C)= ','
//   	      	pPIO->PIO_CODR =(D0|D1|D4|D6|D7) ;
//   	       	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//   	       	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//   	       	pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//    	    pPIO->PIO_SODR =(D1|D2|D4|D6) ;				//envoie du caratre ASCII (0x56)= 'V'
//    	    pPIO->PIO_CODR =(D0|D3|D5|D7) ;
//    	    pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//    	    pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//    	    pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//
//    	    pPIO->PIO_SODR =(D0|D5|D6) ;				//envoie du caratre ASCII (0x61)= 'a'
//    	    pPIO->PIO_CODR =(D1|D2|D3|D4|D7) ;
//    	    pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//    	    pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//    	    pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture
//    	        
//    	    pPIO->PIO_SODR =(D0|D1|D2|D3|D4|D5) ;				//envoie du caratre ASCII (0x3F)= '?'
//    	    pPIO->PIO_CODR =(D6|D7) ;
//    	    pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//    	    pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//    	    pPIO->PIO_SODR = CS_mask|write;									// Dsactive les UART et l'criture

  	        
  	    }
//	volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure		    
//  	AT91F_PIO_CfgInput(AT91C_BASE_PIOA, BUS_DONNEE);
//  	pPIO->PIO_SODR =(A2|A1) ;	
//  	pPIO->PIO_CODR = (A0);
//  	pPIO->PIO_CODR = CSD;
//  	pPIO->PIO_CODR = read;
//  	valeur_registre = (pPIO->PIO_PSR & 0xFF);
//  	pPIO->PIO_SODR = CS_mask|write;	
//  	
//  	if((valeur_registre | 0x01) == 0x01)
//  	{	
//  		AT91F_PIO_CfgOutput( AT91C_BASE_PIOA, BUS_DONNEE ) ;
//  		
//  		pPIO->PIO_SODR =(D2|D6) ;							// envoie du caactre ASCII (0x44)= 'D'
//  		pPIO->PIO_CODR =(D0|D1|D3|D4|D5|D7|A0|A1|A2) ;
//  		pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  		pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  		pPIO->PIO_SODR = CS_mask | write;									// Dsactive les UART
//  	}
//  	else
//  	{ 
//  		if ((valeur_registre | 0x02) == 0x02)
//  		{
//  	 		pPIO->PIO_SODR =(D0|D1|D2|D3|D6) ;							// envoie du caactre ASCII (0x4F)= 'O'
//  	  		pPIO->PIO_CODR =(D4|D5|D7|A0|A1|A2) ;
//  	  		pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  	  		pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	  		pPIO->PIO_SODR = CS_mask | write;									
//  		}
//  		else
//  		{
//  	  		if ((valeur_registre | 0x10) == 0x10)
//  	  		{
//  	  	 		pPIO->PIO_SODR =(D1|D6) ;							// envoie du caactre ASCII (0x42)= 'B'
//  	  	  		pPIO->PIO_CODR =(D0|D2|D3|D4|D5|D7|A0|A1|A2) ;
//  	  	  		pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  	  	  		pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	  	  		pPIO->PIO_SODR = CS_mask | write;									
//  	  		}
//  	  		else
//  	  		{
//  	    		if ((valeur_registre | 0x80) == 0x80)
//  	    		{
//  	    	 		pPIO->PIO_SODR =(D0|D2|D6) ;							// envoie du caactre ASCII (0x45)= 'E'
//  	    	  		pPIO->PIO_CODR =(D1|D3|D4|D5|D7|A0|A1|A2) ;
//  	    	  		pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
//  	    	  		pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
//  	    	  		pPIO->PIO_SODR = CS_mask | write;									
//  	    		}
//  	    		
//  	  		} 
//  		}
//  		
//  	}
 
    //* while SW3 is push loop
//    while ( (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & SW3_MASK ) != SW3_MASK );
//}

//*----------------------------------------------------------------------------
//* Function Name       : FIQ_init_handler
//* Object              : Irq Handler called by the FIQ interrupt with AT91
//*                       compatibility
///*----------------------------------------------------------------------------
//__ramfunc void FIQ_init_handler(void)
//{
//		volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure		  
//    //* Read the output state
//    if ( (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & LED1 ) == LED1 )
//    {
//        AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED1 );
//        pPIO->PIO_SODR = UART_MASK;
//    }
//    else
//    {
//        AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED1 );
//        AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, UART_MASK );
//    }
//
//    
//}

