//*----------------------------------------------------------------------------
//*      ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : interrupt_Usart.c
//* Object              : USART Interrupt Management
//*
//* 1.0 24/Jun/04 JPP   : Creation
//* 1.1 29/Aug/05 JPP   : Update AIC definion
//* slightly modified for the WinARM example - M.Thomas (not Atmel)
//*----------------------------------------------------------------------------

// Include Standard LIB  files
#include "Board.h"


#define USART_INTERRUPT_LEVEL		7
#define AT91_BAUD_RATE				115200
//#define AT91_BAUD_RATE				19200

//int message_recu;
unsigned int message_recu;
static const char atmel_header[]=
{
"\n\r  *** int_usart ATMEL Usart IRQ ***\n\r"
"Copyright (C) 2002 ATMEL Corporations Version: 1.0 (WinARM port)\n\r"
};
//Modification Tibo 1 ajout constante suivante
static const char Tibo_test_1[]=
{
"\n\r  *** Interruption Usart_c_irq_handler ***\n\r"
"Envoie test\n\r"
};



static const char reception[]=
{
"\n\r  *** message recu2 ***\n\r"
};

//* \fn    AT91F_US_Baudrate
//* \brief Calculate the baudrate
//* Standard Asynchronous Mode : 8 bits , 1 stop , no parity
#define AT91C_US_ASYNC_MODE ( AT91C_US_USMODE_NORMAL + \
                        AT91C_US_NBSTOP_1_BIT + \
                        AT91C_US_PAR_NONE + \
                        AT91C_US_CHRL_8_BITS + \
                        AT91C_US_CLKS_CLOCK )

//*------------------------- Internal Function --------------------------------

//*----------------------------------------------------------------------------
//* Function Name       : Usart_c_irq_handler
//* Object              : C handler interrupt function called by the interrupts
//*                       assembling routine
//* Input Parameters    : <RTC_pt> time rtc descriptor
//* Output Parameters   : increment count_timer0_interrupt
//*----------------------------------------------------------------------------
__ramfunc void Usart_c_irq_handler(void)
{
	AT91PS_USART pUS1 = AT91C_BASE_US1;
	int i=0;
	unsigned int status;
	volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure
	//AT91PS_USART COM1 = AT91C_BASE_US1;
	
	//* get Usart status register
	status = pUS1->US_CSR;
	if ( status & AT91C_US_RXRDY)
	{
		//* Get byte and send
		//Modification Tibo 1 ajout SendFrame()
		//AT91F_US_SendFrame(AT91C_BASE_US1,(char *)Tibo_test_1,sizeof(Tibo_test_1)-1,0,0);

//		AT91PS_USART pUSART = AT91C_BASE_US1;
//		message_recu=((pUSART->US_RHR) & 0x1FF);
//		AT91PS_USART COM1 = AT91C_BASE_US1;
//		AT91F_US_SendFrame(COM1,(char *)entete,sizeof(entete)-1,0,0);
//		AT91F_US_SendFrame(COM1,(char *)message_recu,sizeof(message_recu)-1,0,0);
//		AT91F_US_SendFrame(COM1,(char *)entete,sizeof(entete)-1,0,0);
		//message_recu=AT91F_US_GetChar(USART_pt);

		//AT91F_US_SendFrame(COM1,(char *)reception,sizeof(reception)-1,0,0);
	//	AT91F_US_PutChar (USART_pt, message_recu);
	//	AT91F_US_PutChar (USART_pt, '<');	
		//message_recu = pUS1->US_RHR;
		message_recu = AT91F_US_GetChar(pUS1);
		//Modification Tibo 07/04/08 9h50 desactive ligne suivante
		//pUS1->US_THR = message_recu;
		AT91F_US_PutChar(pUS1, message_recu);
		  
		/*AT91F_PIO_CfgOutput(pPIO, BUS_DONNEE);
		AT91F_PIO_ClearOutput(pPIO, CS_mask|BUS_ADDRESS|BUS_DONNEE);
		AT91F_PIO_ForceOutput(pPIO, message_recu);	//Writ PIO_ODSR(enabled by writting PIO_OWER during initialisation)
		//pPIO->PIO_ODSR = message_recu;	//envoie caractere recu

	    //pPIO->PIO_CODR = (A0|A1|A2) ;
	    //pPIO->PIO_CODR = CS_mask;										// active le l'UART selectionn
	    //pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	    //pPIO->PIO_SODR = write;									// Dsactive les UART et l'criture
		AT91F_PIO_ClearOutput(pPIO, write);
		for(i=0;i<100;i++){}
		AT91F_PIO_SetOutput(pPIO, write);*/
		
	//	AT91F_US_PutChar (USART_pt, AT91F_US_GetChar(USART_pt));
	//	AT91F_US_PutChar (USART_pt, '>');
		
	}
	AT91F_US_PutChar(pUS1, 'm');
	AT91F_PIO_CfgOutput(pPIO, BUS_DONNEE);
	AT91F_US_PutChar(pUS1, 'n');
	AT91F_PIO_ClearOutput(pPIO, CS_mask|BUS_ADDRESS|BUS_DONNEE);
	AT91F_US_PutChar(pUS1, 'o');
	AT91F_PIO_ForceOutput(pPIO, message_recu);	//Writ PIO_ODSR(enabled by writting PIO_OWER during initialisation)
	AT91F_US_PutChar(pUS1, 'p');
	//pPIO->PIO_ODSR = message_recu;	//envoie caractere recu
	AT91F_PIO_ClearOutput(pPIO, write);
	AT91F_US_PutChar(pUS1, 'q');
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);
	AT91F_US_PutChar(pUS1, 'r');

	if(status & AT91C_US_OVRE)
	{
		//* clear US_RXRDY
		AT91F_US_GetChar(pUS1);
		AT91F_US_PutChar (pUS1, 'Z');
	}

	//* Check error
	if(status & AT91C_US_PARE)
	{
		AT91F_US_PutChar (pUS1, 'P');
	}

	if(status & AT91C_US_FRAME)
	{
		AT91F_US_PutChar (pUS1, 'F');
	}

	if(status & AT91C_US_TIMEOUT)
	{
		pUS1->US_CR = AT91C_US_STTTO;
		AT91F_US_PutChar (pUS1, 'T');
	}

	AT91F_US_PutChar(pUS1, 's');
	//* Reset the status bit
	 pUS1->US_CR = AT91C_US_RSTSTA;
}
//*-------------------------- External Function -------------------------------

//*----------------------------------------------------------------------------
//* Function Name       : Usart_init
//* Object              : USART initialization
//* Input Parameters    : none
//* Output Parameters   : TRUE
//*----------------------------------------------------------------------------
void Usart_init ( void )
//* Begin
{
	AT91PS_USART COM1 = AT91C_BASE_US1;

 	//* Configure PIO controllers to periph mode
 	AT91F_PIO_CfgPeriph( AT91C_BASE_PIOA,
 		((unsigned int) AT91C_PA21_RXD1    ) |
 		((unsigned int) AT91C_PA22_TXD1    ) , // Peripheral A
 		0); // Peripheral B


   	// First, enable the clock of the PIOB
	AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_US1 ) ;
	// Usart Configure
	AT91F_US_Configure (COM1, MCK, AT91C_US_ASYNC_MODE, AT91_BAUD_RATE, 0);

	// Enable usart
	COM1->US_CR = AT91C_US_RXEN | AT91C_US_TXEN;

    //* Enable USART IT error and RXRDY
    AT91F_US_EnableIt(COM1,AT91C_US_TIMEOUT | AT91C_US_FRAME | AT91C_US_OVRE | AT91C_US_RXRDY);

    //* open Usart 0 interrupt
	AT91F_AIC_ConfigureIt ( AT91C_BASE_AIC, AT91C_ID_US1, USART_INTERRUPT_LEVEL,AT91C_AIC_SRCTYPE_INT_HIGH_LEVEL, Usart_c_irq_handler);
		
	AT91F_AIC_EnableIt (AT91C_BASE_AIC, AT91C_ID_US1);

	// AT91F_US_PutChar (COM1,'m');

	// mt: added -1 since sizeof includes the trailing \0
 	//AT91F_US_SendFrame(COM1,(char *)atmel_header,sizeof(atmel_header)-1,0,0);
 	//AT91F_PDC_SendFrame(((AT91PS_PDC)&(COM1->US_RPR)), (char *)atmel_header, sizeof(atmel_header)-1,0,0);
 	AT91F_US_PutChar(COM1,'1');
 	AT91F_US_PutChar(COM1,' ');

//* End
}
