//*----------------------------------------------------------------------------
//*         ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : main.c
//* Object              : main application written in C
//* 1.0 24/Jun/04 JPP   : Creation
//* 1.1 21/Feb/05 JPP   : Update AT91C_RSTC_URSTEN
//* 1.2 29/Aug/05 JPP   : Update AIC definion
//* slightly modified for the WinARM example - M.Thomas (not Atmel)
//*----------------------------------------------------------------------------

// Include Standard LIB  files
#include "Board.h"

#include "interrupt_timer.h"
#include "ext_irq.h"

int valeur_registre_IER,valeur_registre_LSR,valeur_registre_LCR,valeur_registre_MCR;//,valeur_registre_RHR;
short mesure[2200];

/*static const char Test_4[]=
{
"\n\r  *** Boucle While(1) ***\n\r"
};*/

//*   Waiting time between LED1 and LED2
//#define     WAIT_TIME       MCK

#define PIO_INTERRUPT_LEVEL	6
#define IRQ0_INTERRUPT_LEVEL	2
#define ADC_INTERRUPT_LEVEL	3
#define FIQ_INTERRUPT_LEVEL	0


////	variable config ADC
//#define   TRGEN    (0x0)    // Software triggering
//#define   TRGSEL   (0x0)    // Without effect
//#define   LOWRES   (0x0)    // 10-bit result output
//#define   SLEEP    (0x0)    // Normal Mode
//#define   PRESCAL  (0x9)    // Max value
//#define   STARTUP  (0x19)    // This time period must be higher than 20 s and not 20 ms
//#define   SHTIM    (0x3)    // Must be higher than 3 ADC clock cycles but depends on output
//                            // impedance of the analog driver to the ADC input



// Use the Library Handler defined in file periph/pio/pio_irq/irq_pio.s

// External Function Prototype
extern void FIQ_init_handler(void);
extern void Usart_init(void);

//Modification Tibo 3 desactive extern declaration ci dessous car ajout du #include"ext_irq.h"
//extern void at91_IRQ0_handler(void);
//extern void envoie_UART(char data,int chipsel);
//extern void pio_c_irq_handler(void);


//*----------------------------------------------------------------------------
//* Function Name       : aic_software_interrupt
//* Object              : Software interrupt function
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : at91_pio_write
//*----------------------------------------------------------------------------
//__ramfunc void aic_software_interrupt(void)
//{
//    //* Read the output state
//    if ( (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & LED3 ) == LED3 )
//    {
//        AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED3 );
//    }
//    else
//    {
//        AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED3 );
//    }
//}




//*----------------------------------------------------------------------------
//* Function Name       : ADC_Init
//* Object              : initialisa l'ADC a une frquence d'chantillonnage de 44kHz
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : 
//*----------------------------------------------------------------------------
//void Init_ADC ( void )
//{
//	AT91PS_ADC pADC = AT91C_BASE_ADC;
//	
//	/* First step: Enable ADC's Clock at PMC level.*/
//	  AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_ADC ) ;
//	  
//	  /* Second step: Set up by using ADC Mode register */
//	  running_mode = ((SHTIM << 24) | (STARTUP << 16) | (PRESCAL << 8) | (SLEEP << 5) | (LOWRES <<4) | (TRGSEL << 1) | (TRGEN ));
//	  AT91F_ADC_CfgModeReg (AT91C_BASE_ADC, running_mode) ;
//	  
//	  /* Third Step: Select the active channel */
////	AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_ADC )
//	pADC->ADC_MR = 0x3f00;	
//	
////	Slectionne les entres ADC actives
//	pADC->ADC_CHER = 0x30;
//}

//*----------------------------------------------------------------------------
//* Function Name       : ADC_handler
//* Object              : sauvegarde l'chantillon dans le tableau mesure
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : 
//*----------------------------------------------------------------------------
//__ramfunc void ADC_handler ( void )
//{
//	mesure[i]=ADC_CDR4
//	i++;
//	if(i<2200)
//	{
//		pADC->ADC_CR = 0x2;		// dbut de conversion 
//	}
//	else i=0;
//
//}





//*----------------------------------------------------------------------------
//* Function Name       : main
//* Object              : Main interrupt function
//*		level timer 0 => 1
//*	SW2	level Irq0    => 2
//*		level timer 1 => 4
//*	SW4	level PIOA    => 6
//*		level USART   => 7
//*		LEVEL FIQ     => MAX
//* Input Parameters    : none
//* Output Parameters   : TRUE
//*----------------------------------------------------------------------------
int main(void)
{
	AT91PS_AIC pAic = AT91C_BASE_AIC;	//pointer to AIC BASE Address
    AT91PS_PIO pPIO = AT91C_BASE_PIOA;	//pointer to PIOA Base Address
    int i=0;

    //* Enable User Reset and set its minimal assertion to 960 us
	//AT91C_BASE_RSTC->RSTC_RMR = AT91C_RSTC_URSTEN | (0x4<<8) | (unsigned int)(0xA5<<24);
	AT91F_RSTSetMode(AT91C_BASE_RSTC, AT91C_RSTC_URSTEN|(0x4<<8));

	//*Init Timer0
	init_T0();
	//* Init Usart
	Usart_init();
	//* Init
//     	loop_count = 0 ;
    	// First, enable the clock of the PIOB
    AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOA);
    
    //Modification Tibo 2 ligne suivante
    //AT91F_PIO_CfgOutput( AT91C_BASE_PIOA,sorties|UART_MASK ) ;
    AT91F_PIO_CfgOutput(pPIO, sorties|UART_mask);

//	// mt: added reset enable to make the board reset-button "useful"
//	AT91F_RSTSetMode( AT91C_BASE_RSTC , AT91C_RSTC_URSTEN );

    AT91F_PIO_CfgInput(AT91C_BASE_PIOA, entrees|INTERRUPT_mask);

    AT91F_AIC_ConfigureIt(pAic, AT91C_ID_PIOA, PIO_INTERRUPT_LEVEL, AT91C_AIC_SRCTYPE_POSITIVE_EDGE, pio_c_irq_handler);
    AT91F_PIO_InterruptEnable( AT91C_BASE_PIOA,INTERRUPT_mask);
	//* set the interrupt by software
	AT91F_AIC_EnableIt(pAic, AT91C_ID_PIOA);

	//Init ACE TL16C554FN
	AT91F_PIO_CfgOutput(pPIO, UART_mask);							// PIO Output Enable Register - sets pins P0 - P3 to outputs
	//AT91F_PIO_CfgDirectDrive(pPIO, 0x000000FF);						//Write PIO_OWER(enable direct access to PIO_ODSR(Output Data Status Register)
   	pPIO->PIO_OWER = 0x000000FF;
	AT91F_PIO_SetOutput(pPIO, read|write);							//Disable read/write
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|CS_mask|BUS_DONNEE);	//Clear Address, Chip Select and Data_Bus

	//Configure FCR(FIFO Control Register) on Channel A
	//FCR=00000001 Enable FIFO with Trigger level on 1 Byte
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|CS_mask|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, A1|D0);
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);

	//Configure MCR(Modem Control Register) on Channel A
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, A2|D3);
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);

	//Configure LCR(Line Control Register) on Channel A
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, A1|A0|D7|D6|D1|D0);
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);

	//Configure DLL(Divisor latch LSB) for 19200 Baud
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, D2|D1);
	//AT91F_PIO_SetOutput(pPIO, D5|D2|D1);//300 bauds
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);

	//Configure DLM(Divisor latch MSB) for 19200 Baud
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, A0);
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);

	//Configure LCR(Line Control Register) on Channel A
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, A1|A0|D6|D1|D0);
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);

	//Configure IER(Interrupt Enable Register) on Channel A
	AT91F_PIO_ClearOutput(pPIO, BUS_ADDRESS|BUS_DONNEE);
	AT91F_PIO_SetOutput(pPIO, A0|D2|D0);
	AT91F_PIO_ClearOutput(pPIO, write);
	for(i=0;i<100;i++){}
	AT91F_PIO_SetOutput(pPIO, write);
	//AT91F_US_SendFrame(AT91C_BASE_US1,(char *)"fin init main\n\r",15-1,0,0);
	AT91F_US_PutChar(AT91C_BASE_US1,'F');
	AT91F_US_PutChar(AT91C_BASE_US1,'i');
	AT91F_US_PutChar(AT91C_BASE_US1,'n');
	AT91F_US_PutChar(AT91C_BASE_US1,' ');
	AT91F_US_PutChar(AT91C_BASE_US1,'i');
	AT91F_US_PutChar(AT91C_BASE_US1,'n');
	AT91F_US_PutChar(AT91C_BASE_US1,'i');
	AT91F_US_PutChar(AT91C_BASE_US1,'t');
	AT91F_US_PutChar(AT91C_BASE_US1,'\n');
	AT91F_US_PutChar(AT91C_BASE_US1,'\r');


   	/*pPIO->PIO_SODR = (A1); 				// cfg registtre FCR, FIFO enable,trigger level 1 bits (0x40000001)
	pPIO->PIO_CODR = (D0|D1|D2|D3|D4|D5|D6|D7|A0|A2);
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture

	pPIO->PIO_SODR =(D3|A2);			// cfg registtre MCR, enable int. ext. (0x80000008)
	pPIO->PIO_CODR =(D0|D1|D2|D4|D5|D6|D7|A0|A1) ;
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture

	pPIO->PIO_SODR =(D0|D1|D7|A0|A1);		// cfg registre LCR,8 bits,1 bit de stop, pas de parit, active DLAB (0x60000083) 
	pPIO->PIO_CODR =(D2|D3|D4|D5|D6|A2) ;
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture

	pPIO->PIO_SODR =(D1|D2) ;			// cfg registre DLL pour 19200 bauds (0x00000006)
	pPIO->PIO_CODR =(D0|D3|D4|D5|D6|D7|A0|A1|A2) ;
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
   	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture

	pPIO->PIO_SODR =(A0) ;			// cfg registre DLM pour 19200 bauds  (0x20000000)
	pPIO->PIO_CODR =(D0|D1|D2|D3|D4|D5|D6|D7|A1|A2) ;
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture

	pPIO->PIO_SODR =(D0|D1|A0|A1) ;			// cfg registre LCR, Dsactive DLAB (0x60000003)
	pPIO->PIO_CODR =(D2|D3|D4|D5|D6|D7|A2) ;
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture

	pPIO->PIO_SODR =(D0|D2|A0) ;			// cfg registtre IER, RX data available,THR et Modem status disable (0x20000005)
	pPIO->PIO_CODR =(D1|D3|D4|D5|D6|D7|A1|A2) ;
	pPIO->PIO_CODR = CSD;										// active le l'UART selectionn
	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
	pPIO->PIO_SODR = CS_mask|write;								// Dsactive les UART et l'criture*/

	while(1)
	{
		/*AT91F_PIO_SetOutput(AT91C_BASE_PIOA, UART_mask);
		for(i=0; i<10; i++)
		{}
		AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, UART_mask);*/
		/*for(unsigned int w=0;w<1000000;w++)
		{
			loop_count=0;
			while(loop_count<1000000);
			{
				loop_count=loop_count+1;
			}
		}
		AT91F_US_PutChar (USART_pt, 'w');*/
	}
//    //* open external IRQ interrupt
//   	AT91F_PIO_CfgPeriph(AT91C_BASE_PIOA,SW2_MASK,0);
//   	//* open external IRQ0 interrupt
//	AT91F_AIC_ConfigureIt ( pAic, AT91C_ID_IRQ0, IRQ0_INTERRUPT_LEVEL,AT91C_AIC_SRCTYPE_EXT_NEGATIVE_EDGE, at91_IRQ0_handler);
//	AT91F_AIC_EnableIt (pAic, AT91C_ID_IRQ0);

//    //* Open the software interrupt on the AIC
//	AT91F_AIC_ConfigureIt ( pAic, AT91C_ID_SYS, SOFT_INTERRUPT_LEVEL, AT91C_AIC_SRCTYPE_INT_POSITIVE_EDGE,  aic_software_interrupt);
//	AT91F_AIC_EnableIt (pAic, AT91C_ID_SYS);

//    //* open  FIQ interrupt
//	AT91F_PIO_CfgPeriph(AT91C_BASE_PIOA,SW1_MASK,0);
//	AT91F_AIC_ConfigureIt ( pAic, AT91C_ID_FIQ, FIQ_INTERRUPT_LEVEL,AT91C_AIC_SRCTYPE_EXT_NEGATIVE_EDGE, FIQ_init_handler);
//	AT91F_AIC_EnableIt (pAic, AT91C_ID_FIQ);
	//* generate FIQ interrupt by software
	//AT91F_AIC_Trig (pAic,AT91C_ID_FIQ) ;

//    //* Init timer interrupt
	//Modification Tibo 2 desactive timer_init(); suivant
       //timer_init();
//Modification Tibo 2 dcalage Usart_init() au debut du Main
    //* Init Usart
	//Usart_init();

//    //* generate software interrupt
//        AT91F_AIC_Trig (pAic,AT91C_ID_SYS) ;

    	// Configuration de l'UART //
	//Modification Tibo 2 desactive toutes les lignes suivante jusqu'au while(1)
    	/*volatile AT91PS_PIO	pPIO = AT91C_BASE_PIOA;			// pointer to PIO data structure
    	pPIO->PIO_OER =  UART_MASK ;							// PIO Output Enable Register - sets pins P0 - P3 to outputs	
    	pPIO->PIO_OWER = 0x000000FF;
    	pPIO->PIO_SODR = read |write | CS_mask;	
    	
    	pPIO->PIO_SODR = (D0|A1); 				// cfg registtre FCR, FIFO enable,trigger level 1 bits (0x40000001)
    	pPIO->PIO_CODR = (D1|D2|D3|D4|D5|D6|D7|A0|A2);
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture
    	
    	pPIO->PIO_SODR =(D0|D2|A0) ;			// cfg registtre IER, RX data available,THR et Modem status disable (0x20000005)
    	pPIO->PIO_CODR =(D1|D3|D4|D5|D6|D7|A1|A2) ;
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture
    	
    	pPIO->PIO_SODR =(D3|A2);			// cfg registtre MCR, enable int. ext. (0x80000008)
    	pPIO->PIO_CODR =(D0|D1|D2|D4|D5|D6|D7|A0|A1) ;
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture
    	
    	pPIO->PIO_SODR =(D0|D1|D7|A0|A1);		// cfg registre LCR,8 bits,1 bit de stop, pas de parit, active DLAB (0x60000083) 
    	pPIO->PIO_CODR =(D2|D3|D4|D5|D6|A2) ;
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture
    	
    	pPIO->PIO_SODR =(D1|D2) ;			// cfg registre DLL pour 19200 bauds (0x00000006)
    	pPIO->PIO_CODR =(D0|D3|D4|D5|D6|D7|A0|A1|A2) ;
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture

    	
    	pPIO->PIO_SODR =(A0) ;			// cfg registre DLM pour 19200 bauds  (0x20000000)
    	pPIO->PIO_CODR =(D0|D1|D2|D3|D4|D5|D6|D7|A1|A2) ;
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture
    	
    	pPIO->PIO_SODR =(D0|D1|A0|A1) ;			// cfg registre LCR, Dsactive DLAB (0x60000003)
    	pPIO->PIO_CODR =(D2|D3|D4|D5|D6|D7|A2) ;
    	pPIO->PIO_CODR = (CS1|CS2);										// active le l'UART selectionn
    	pPIO->PIO_CODR = write;										// Active l'criture de l'UART 
    	pPIO->PIO_SODR = write;								// Dsactive les UART et l'criture*/


//        loop_count ++ ;
//		//* Set LED by software interrupt
//        if (loop_count == 10)
//        {
//			 loop_count=0;
//			//* Software interrupt
//			 AT91F_AIC_Trig (pAic,AT91C_ID_SYS) ;
//        }
}

//* End

